#!/bin/sh
# hack
# assumes the following layout:
# project dir/
#	warnings.sh: this file
# 	logs/: directory containing the output of make all 2>&1 | tee <...>/logs/make.log 

egrep -i "warning: |Entering directory" logs/make.log | egrep -v "/opt/gnome/include/" >logs/warnings.all
egrep -i "no previous declaration" logs/warnings.all >logs/warnings.noprevious
egrep -i "is always" logs/warnings.all >logs/warnings.always
egrep -i "never be executed" logs/warnings.all >logs/warnings.never
egrep -i "aliasing" logs/warnings.all >logs/warnings.aliasing
egrep -i "clobbered" logs/warnings.all >logs/warnings.clobbered
egrep -i "unused " logs/warnings.all >logs/warnings.paramunused
egrep -i "to function pointer|between function pointer" logs/warnings.all >logs/warnings.fpointer
egrep -i "isn.t a prototype" logs/warnings.all >logs/warnings.isntprototype
egrep -i "uninitialized " logs/warnings.all >logs/warnings.uninitialized
egrep -i "defined but not " logs/warnings.all >logs/warnings.varunused
egrep -i "not match function type" logs/warnings.all >logs/warnings.castfunctype
egrep -i "incompatible pointer" logs/warnings.all >logs/warnings.incompatible
egrep -i "discards qualifier" logs/warnings.all >logs/warnings.qualifier
egrep -i "attribute warn_unused_result" logs/warnings.all >logs/warnings.unusedresult
egrep -i "printf length modifier$|printf format$|long long integer" logs/warnings.all >logs/warnings.longlong
egrep -i "cast from function call|integer from pointer" logs/warnings.all >logs/warnings.cast
egrep -i "computable at load time" logs/warnings.all >logs/warnings.computable
egrep -i "ignored on asm" logs/warnings.all >logs/warnings.asmignored
egrep -i "variadic macros" logs/warnings.all >logs/warnings.variadic
egrep -i "braced-groups" logs/warnings.all >logs/warnings.braced
egrep -i "string length" logs/warnings.all >logs/warnings.stringlength
egrep "WARNING:" logs/warnings.all >logs/warnings.WARNING
egrep -i "changing search order|non-system directory" logs/warnings.all >logs/warnings.searchorder
egrep -i "only one void side" logs/warnings.all >logs/warnings.onevoid
egrep -i "comma " logs/warnings.all >logs/warnings.comma
egrep -i "extra .;" logs/warnings.all >logs/warnings.semicolon
egrep -i " format, " logs/warnings.all >logs/warnings.format
egrep -i " expects type " logs/warnings.all >logs/warnings.expectstype
egrep -i " different width " logs/warnings.all >logs/warnings.width
egrep -i " shadows a |shadowed declaration" logs/warnings.all >logs/warnings.shadow
egrep -i "integer implicitly converted|signed due to prototype|differ in signedness|comparison between" logs/warnings.all >logs/warnings.signedness
egrep -v "never be executed|no previous declaration|expects type|only one void side|integer implicitly converted| different width |printf length modifier$|printf format$|long long integer|cast from function call|integer from pointer|computable at load time|attribute warn_unused_result|signed due to prototype|is always|comparison between | shadows a |shadowed declaration|conversion of|not match function type|variadic macros|isn.t a prototype|aliasing|clobbered| format, |extra .;|to function pointer|between function pointer|string length|comma |unused |braced-groups|differ in signedness|uninitialized |defined but not |incompatible pointer|Entering directory|discards qualifier|ignored on asm|WARNING:|changing search order|non-system directory" logs/warnings.all >logs/warnings.rest

find logs -size 0 | xargs rm
